import { AfterViewInit, ElementRef, EventEmitter, Injector, OnDestroy, OnInit, SimpleChange } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Ng2TreeSettings, NodeCollapsedEvent, NodeExpandedEvent, NodeSelectedEvent, Tree, TreeComponent, TreeModel } from 'o-ngx-tree';
import { LoadNextLevelEvent } from 'o-ngx-tree/src/tree.events';
import { DialogService, LocalStorageService, NavigationService, OFormComponent, OServiceComponent, OTranslateService, SQLOrder } from 'ontimize-web-ngx';
import { Subscription } from 'rxjs';
import { OTreeNodeComponent } from './o-tree-node.component';
export declare const DEFAULT_BASIC_INPUTS_O_TREE: string[];
export declare const DEFAULT_INPUTS_O_TREE: string[];
export declare const DEFAULT_OUTPUTS_O_TREE: string[];
export declare class OTreeComponent extends OServiceComponent implements OnInit, AfterViewInit, OnDestroy {
    protected elRef: ElementRef;
    protected form: OFormComponent;
    static DEFAULT_INPUTS_O_TREE: string[];
    static DEFAULT_BASIC_INPUTS_O_TREE: string[];
    static DEFAULT_OUTPUTS_O_TREE: string[];
    static DEFAULT_ROOT_ROUTE: string;
    protected sortColumns: string;
    protected descriptionColumns: string;
    protected expandAllNodes: boolean;
    protected separator: string;
    protected parentColumn: string;
    showRoot: boolean;
    protected rootTitle: string;
    recursive: boolean;
    recursiveLevels: number;
    translate: boolean;
    protected route: string;
    controls: boolean;
    static: boolean;
    rightMenu: boolean;
    refreshButton: boolean;
    quickFilter: boolean;
    quickFilterColumns: string;
    filterCaseSensitive: boolean;
    showButtonsText: boolean;
    protected sortColArray: Array<SQLOrder>;
    protected descriptionColArray: Array<string>;
    protected quickFilterColArray: string[];
    protected dataResponseArray: any[];
    protected expandedNodesIds: any[];
    oTitle: string;
    treeNodes: OTreeNodeComponent[];
    onNodeSelected: EventEmitter<any>;
    onNodeExpanded: EventEmitter<any>;
    onNodeCollapsed: EventEmitter<any>;
    onLoadNextLevel: EventEmitter<any>;
    treeComponentRef: TreeComponent;
    rootTreeModel: TreeModel;
    settings: Ng2TreeSettings;
    selectedNode: Tree;
    protected localStorageService: LocalStorageService;
    protected dialogService: DialogService;
    protected router: Router;
    protected actRoute: ActivatedRoute;
    protected translating: boolean;
    protected translateService: OTranslateService;
    protected onLanguageChangeSubscription: Subscription;
    protected filteringTree: boolean;
    resetingTree: boolean;
    protected navigationService: NavigationService;
    constructor(injector: Injector, elRef: ElementRef, form: OFormComponent);
    readonly treeComponent: TreeComponent;
    getComponentKey(): string;
    getDataToStore(): {};
    ngOnInit(): void;
    ngAfterViewInit(): void;
    afterViewInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: {
        [propName: string]: SimpleChange;
    }): void;
    initialize(): void;
    onLanguageChangeCallback(): void;
    protected translateChildren(treeModel: TreeModel): void;
    setDataArray(data: any): void;
    registerTreeNode(oTreeNode: OTreeNodeComponent): void;
    getComponentFilter(existingFilter?: any): any;
    getRecursiveChildren(id: any, callback: any): void;
    getTreeNodesChildren(itemdata: any, callback: any): void;
    protected doChildQuery(queryMethodName: string, queryArguments: any[], callback: any): void;
    protected mapTreeNode(itemdata?: any, treeNodeComponent?: OTreeComponent): TreeModel;
    protected getNodeId(item?: any): string;
    protected getNodeDescription(item?: any): string;
    reloadData(): void;
    protected setData(treeArray: any[]): void;
    protected expandAll(nodes: TreeModel[]): void;
    protected resetTree(): void;
    filterData(value?: string, loadMore?: boolean): void;
    nodeSelected(event: NodeSelectedEvent): void;
    protected innerNodeSelected(data: any, node: Tree): void;
    nodeExpanded(event: NodeExpandedEvent): void;
    nodeCollapsed(event: NodeCollapsedEvent): void;
    nextLevelLoaded(event: LoadNextLevelEvent): void;
    executeNodeActionById(id: number | string, action: string): void;
    hasTitle(): boolean;
    useQuickFilter(): boolean;
    protected filterTreeUsingFilter(filter: any): void;
    protected filterNodesUsingFilter(item: TreeModel, filter: string): void;
    protected filterBranch(item: TreeModel, filter: string): void;
    protected filterLeaf(item: TreeModel, filter: string): void;
    protected getStringForSearch(item: TreeModel): string;
    protected getQueryConfiguration(): any;
    protected getKeysValues(): any[];
    protected storeNavigationFormRoutes(activeMode: string, queryConf?: any): void;
}
export declare class OTreeComponentModule {
}
